#  TODO: Tested with grid and vector plot. Not all plot options tested. Documentation needs to be updated. 
#
#' Plot 2D field on unstructured grid
#' 
#' Plot representation of a 2D field as either a grid box plot, filled contour or contour plot.
#' It is possible to add map features (borders, rivers, lakes, etc.) to the plot using the
#' \code{\link{map}} function. Drawing of map features on different coordinate systems (projections
#' is supported either through mapproject or rgdal functionality (see details below). 
#' 
#' @param x locations of grid cell centers in x-direction at which the values in \code{z} are
#'		measured. These must be in ascending order.  By default, equally
#'		spaced values from 0 to 1 are used.  If \code{x} is a \code{list},
#'		its components \code{x$x} are used for \code{x}. If the list has component \code{para} this
#'  	is used for \code{z}. Furthermore, projection features can be passed through components
#' 		of \code{x}. If a set of parameters \code{projection}, \code{orientation} and 
#'		\code{parameters} is present, the \code{\link{mapproject}} functionality is used to 
#'		draw map features on projected grids. If a component \code{proj4string} (character) 
#'		is present, the \code{rgdal} library is used together with \code{\link{spTransform}} 
#'		is used to obtain and plot map features on projected grids.
#' @param y locations of grid cell centers in y-direction at which the values in \code{z} are
#'     measured. These must be in ascending order. By default, equally
#'     spaced values from 0 to 1 are used.
#' @param z a 2D or 3D array containing the values to be plotted (\code{NA}s are allowed).  
#' 		Note that passing a \code{list} to \code{x} can be used instead of \code{z} for passing
#' 		additional features of the array (projection).
#' @param xlim Range of the plot in x-direction. xlim will overwrite limites given by \code{x}.
#' @param ylim Range of the plot in y-direction. xlim will overwrite limites given by \code{y}.
#' @param lev If \code{z} is a 3D array \code{lev} is the index of the thrid dimension (vertical
#' 		level) that should be plotted.
#' @param levels A set of levels which are used to partition the range of \code{z}. 
#'		Must be \bold{strictly} increasing (and finite).  Areas with \code{z} values between 
#' 		consecutive levels are painted with the same color. Values outside the range of lelvels are
#' 		treated depending on the settings of \code{open.scale}.
#' @param nlevels}{if \code{levels} is not specified, the range of \code{z} is divided 
#' 		into approximately \code{nlevels} levels.
#' @param color.palette A color palette function to be used to assign colors in the plot. Default
#' 		\code{\link{blue.red.colors}}
#' @param palette.par Named list of parameters passed to \code{color.palette}.
#' @param col An explicit set of colors to be used in the plot. This argument overrides any 
#' 		\code{color.palette} function specification. The length of \code{col} has to be one less
#' 		than that of \code{levels}. 
#' @param inv.cols (logical) if TRUE the order of colors returned by \code{color.palette} will be
#' 		turned around. 
#' @param hide.lowest (logical) If TRUE lowest color level will be displayed on plot but not in 
#' 		the colorscale. Can be used when working with blank values for example for a land sea mask 
#' 		representation to fill the background. 
#' @param plot.title (character) Title to be printed centered above main plot. 
#' @param plot.axes (function) Function to be executed instead of standard drawing of x- and y-axis.
#' @param axes (logical) If TRUE plot standard x- and y-axis. If FALSE no axis or box around figure
#'				region are drawn. 
#' @param frame.plot (logical) If TRUE plot box around plot. 
#' @param xaxs The x axis style. The default is to use internal labeling.
#' @param yaxs The y axis style. The default is to use internal labeling. 
#' @param xlab (character) Label for x-axis.
#' @param ylab (character) Label for y-axis.
#' @param asp (numeric) The \eqn{y/x} aspect ratio, see \code{\link{plot.window}}.
#' @param plot.key (logical) If TRUE a legend of the color scale is drawn next to the main plot. 
#' 		This will reset the plot layout. If FALSE only the main plot is drawn into the current plot
#' 		area.  
#' @param key.pos (integer) Where to plot the colorscale, 1: bottom, 2: left, 3:  top, 4: right 
#' 		(default: right) 
#' @param key.title (character or expression) Title to be printed on plot key, usually the displayed
#' 		variable's name.
#' @param key.axes (function) Function which draws axix on the plot key. This overrides the default 
#' 		call to	\code{\link{axis}}.
#' @param key.las (numeric) Text orientation of axis labels for key axis, see \code{\link{par}}.
#' @param key.format (character) If not NULL printf-style format string used for key axis labels, 
#' 		for format options see\code{\link{sprintf}}.
#' @param key.border border color used for separating colors in color legend. Use NA for no
#'			borders
#' @param open.scale (logical) Infulences how values of \code{z} outside the given value range 
#' 		\code{zlim} are treated. If TRUE these values are drawn with the same colour as the 
#' 		extremes given by \code{zlim}. In this case the colour scale will indicate the open range
#' 		by triangular ends. If FALSE values outside \code{zlim} are clipped and not drawn. The 
#' 		colour scale in this case has rectangular ends. 
#' @param log.scale (logical) If TRUE the values in \code{z} are log-transformed 
#' 		(\code{\link{log10}}) before being drawn. The colour scale will still show the original
#' 		value range. 
#' @param add (logical) If TRUE no new plot is started but the current plot is added to the 
#' 		active plot region, no colour scale will be drawn. Default is FALSE.
#' @param plot.numbers (logical) If TRUE print the value of each grid cell in \code{z} to the
#' 		plot. Default is FALSE.
#' @param grid.borders Color for grid cell borders (if type 'grid'). 
#'			Used in call to \code{\link{rect}}. Default	is NA, which means draw no borders. 
#'			TRUE uses same color as shading color.	NULL means par("fg").
#' @param rotate (logical) If TRUE the 2D array \code{z} is flipped before drawning. See 
#' 		\code{\link[myRtools]{flip.grid}}. Default is FALSE.
#' @param borders (logical) should geographical features like administrative borders be drawn. 
#' 		By default low resolution global world country borders as represented by the 'world' 
#' 		dataset in the \code{maps} package are used. To use different datasets use the 
#' 		parameters \code{map.db} and \code{map.source}.
#' @param map.db (character (vector) or list) Entries can be (character): name of a map dataset 
#'      from the 'maps' or 'mapdata' packages, custom dataset in any other package or 
#'		path to a shapefile. If passed as list, individual entries can either be one of 
#		the character types or a Spatial object. 
#'		The following parameters (\code{map.source}, 
#' 		\code{borders.col}, \code{map.lwd}, \code{map.lty}, \code{map.fill}) should be of 
#' 		the same length as \code{map.db} or will be recycled if they are shorter. 
#' @param map.source (character (vector)) Gives the map source type and hence the 
#'		information where to look for the dataset specified in \code{map.db}. Possible values 
#'		are 'maps' for datasets
#' 		from the 'maps' and 'mapdata' packages, 'shapefile' if \code{map.db} points to a shapefile,
#' 		the name of any other package that contains a map dataset, or 'sp' if map.db contains a
#'		Spatial object. 
#' @param borders.col Color for drawing administrative borders.
#' @param map.lwd Line width for administrative borders.
#' @param map.lty Line type for administrative borders.
#' @param map.fill (logical) fill administrative elements?
#' @param cities (logical) Should cities be added to map. City locations are taken from the 
#' 		'cities' data. See \code{\link{map.cities}} for details. 
#' @param cities.par Additional arguments to call to \code{\link{map.cities}} provided as a 
#'				named list. Default values are 'minpop=1E5', 'label=FALSE', 'capitals=1'.
#' @param pnts (list) Location of additional markers/symbols to be plotted on top of map. The 
#'				list has to contain location as 'x' and 'y' values and labels as list item 'name'. 
#'				It is assumed that the position is given coordinates of the plot or long/lat if
#'				geo-referenced plot is produced.
#'				The labels are optional. The following additional list items can be used to 
#'				influece the symbal and label style: 'pch', 'col', 'bg', 'lwd', 'cex', 'font', 
#'				'font.cex'.
#'				The list item 'pos' will define the label position: 1: below; 2: left, 3: top, 
#'				4: right. 
#' @param plot.grid If 'TRUE' will add a grid to the plot. If non-projected this will agree 
#'				with the x and y axis ticks. Else it will be the projected long/lat grid.
#' @param grid.col color used for the grid
#' @param bg.img Background image. Can be used to add a simple secondary image in the background
#'				of the plot. There will be no color scale attached to it. 
#' @param bg.col COlors used for background image. 
#' @param bg.zlim Value limits of background image. 
#' @param type One of 'contour' (default), 'grid', 'vector' and 'nothing'. Contour and grid 
#'				will produce 2D representation of a scalar variable. Vector will create a 
#'				vector plot. Nothing will only set up the plot region, but plot nothing.
#' @param contour.lines If 'TRUE' and 'type' is 'contour', this will add contour lines to the 
#'				filled contour plot. A contour level will be drawn for every color level. The 
#'				style of the contour lines can be set through parameters 'cntr.col', 'cntr.lwd'.
#' @param cntr.col	Colour of contour lines. This can be a vector to give different colors to 
#'				different contour levels. 
#' @param cntr.lwd	Line width of contour lines. Can be a vector. 
#' @param cntr.lty	Line type of contour lines. Can be a vector. 
#' @param cntr.drawlabels If 'TRUE' contour lines will be labeled with their value.
#' @param cntr.labcex Size of contour labels. 
#' @param is.chron If 2D array represents time. Use TRUE to force a color bar with time labels.
#' @param vec.col Colour of vectors if 'type' is 'vector'. 
#' @param vec.lwd.par Line width of vectors.
#' @param vec.len Length of refernce vector in inches. Default is NULL which means that it will be
#'				set automatically. 
#' @param vec.legend Text added to a legend annotating the reference vector. 
#' @param vec.leg.pos Location of vector legend. Possible values are 'topleft', 'topright', 
#'				'bottomleft', 'bottomright'. 
#' @param vec.leg.col Background color for vector legend. 
#' @param vec.ref Length of reference vector in units of field.
#' @param vec.x.skip If larger 0 skip every 'vec.x.skip' entry in x-direction.
#' @param vec.y.skip If larger 0 skip every 'vec.y.skip' entry in y-direction.
#' @param add.vec.length If 'TRUE' and type is 'vector' the absolute value of the vectors is plotted
#'				as a background and a color scale is added.
#' @param ...
#' 
#' @return 
#'   A list of colorscale parameters as used by \code{\link{plot.colorpalette}}
#' 	\item{levels}{ (numeric) values of color breaks }
#'  \item{color}{ color representation, length of length(levels)-1 }
#'  \item{las}{ (numeric) orientation of axis labels}
#'  \item{key.pos}{ (numeric) one of 1:4, determines the orientation of the color map}    
#'  \item{log.scale}{(logical) log-scaling}      
#'  optional fields
#'  \item{key.axes}{function plotting axes, overwrites standard }      
#'  \item{key.format}{format string used for log scale labels, applied in \code{\link{sprintf}} } 
#'  \item{key.title}{title of color map}
#' 
#' @examples 
#' print("Hello example")
#' 
#' @export 
plot.unstr.grid = function(field, grid.def, para, xlim=NULL, ylim=NULL, 
	zlim=NULL, lev, levels, nlevels = 20, color.palette = blue.red.colors, 
    palette.par, col, inv.cols = FALSE, hide.lowest = FALSE,  
	plot.title, plot.axes, axes = !add, frame.plot = axes,  
	xaxs = "i", yaxs = "i", xlab = "", ylab = "", asp = NA, 
	plot.key = TRUE, key.pos = 4, key.title, key.axes, key.las=1, 
	key.format=NULL, key.border=NULL, open.scale = TRUE, log.scale = FALSE,  
	add = FALSE, plot.numbers = FALSE, grid.borders = NA, rotate = FALSE, 	
	borders = FALSE, map.db = "world", map.source = "maps",  
	borders.col = par("fg"), map.lwd = par("lwd"), map.lty=1, map.fill=FALSE,	
	cities = FALSE, 
	cities.par = list(minpop = 1E5, label=FALSE, capitals=1), 
	pnts = list(x = NULL, y = NULL, name = NULL), 
	plot.grid = FALSE, grid.col="gray", grid.lty=3, grid.lwd=1,
	bg.img=NULL, bg.col=heat.colors, bg.zlim=NULL, 
	type = c("grid", "vector"),  
	is.chron = FALSE,
	vec.col=1, vec.lwd=par("lwd"), vec.len=NULL, vec.legend=NULL, vec.leg.pos="bottomleft",
	vec.leg.col = "white", vec.ref=NULL, vec.x.skip=0, vec.y.skip=0,
	add.vec.length=FALSE,
    ... ) 
{
    is.factor = FALSE 	

	type = match.arg(type)

	if (missing(para)){
		if (type=="vector"){
			para = c("uu", "vv")
		} else {
			para = "zz"
		}
	}

	if (cities){
		if (is.null(cities.par$label)) cities.par$label=FALSE
	}

	if (type=="vector" && !add.vec.length){
		plot.key=FALSE
	}

	#	no key can be added when 2dplot is just added to current plot area
	if (add) plot.key = FALSE

	#	check if grid definition and field are complete
    if (missing(field)) {
        if (!missing(grid.def)) {  
            if (class(grid.def)=="unstr.grid") {
				field = grid.def
				if (!is.null(grid.def$grid.def)){	
					grid.def = grid.def$grid.def
				} else {
					stop("No grid definition found.")
				}
            } else {
				stop("unstructured data 'field' has to be given")
            }
        } else {
			stop("unstructured data 'field' and definition 'grid.def' 'have to be given")
		}
    } 
	if (missing(grid.def)){
		if (!is.null(field$grid.def)){	
			grid.def = field$grid.def
		} else {
			stop("unstructured grid definition 'grid.def' 'has to be given")
		}
	}
	#	copy data to be plotted 
	if (type=="vector"){
		uu = field[[para[1]]] 
		vv = field[[para[2]]] 
		z = sqrt(uu^2+vv^2)
	} else {
		z = field[[para]]
	}

	#	check if GDAL projection information is present
	use.rgdal = FALSE
	if (!is.null(field)){ 
		if (!is.null(field$proj4string)){
			if (!is.na(field$proj4string)) {
				if (field$proj4string!="+proj=longlat +ellps=WGS84 +datum=WGS84"){
					use.rgdal = TRUE
					if (!require(sp) || !require(rgdal)) {
						warning(paste("sp and rgdal packages required for PROJ4 projections.",
							"Plotting without projection information."))
						use.rgdal = FALSE
					}
				}
			}
		}
	}

	#	select level if z 3D
	if (length(dim(z))==2){
		if (missing(lev)) lev = 1
		if (lev>dim(z)[2]) {
			warning("Selected level out of range")
			return(NULL)
		}	
		z = z[,lev]
		if (type=="vector"){
			uu = uu[,lev]
			vv = vv[,lev]
		}
	}

	
    if (is.factor(z)){
		is.factor = TRUE
		open.scale = FALSE
		type = "grid"
		fac.levels = levels.default(z)
		dim.z = dim(z)
		z = as.numeric(z)
		dim(z) = dim.z
	}
	
    #   original range (used for borders, etc.)
	if (missing(xlim)) xlim.ll = range(grid.def$cell$lon, na.rm=TRUE)
	else xlim.ll = xlim

	if (missing(xlim) || is.null(xlim)){
		xlim = range(grid.def$cell$lon, na.rm=TRUE)
	}

	if (missing(ylim)) ylim.ll = range(grid.def$cell$lat, na.rm=TRUE)
	else ylim.ll = ylim

	if (missing(ylim) || is.null(ylim)){
		ylim = range(grid.def$cell$lat, na.rm=TRUE)
	}

	#	impose a maks on all data 
	fld.msk = which(grid.def$cell$lon>=xlim[1] & grid.def$cell$lon<=xlim[2] &
	    grid.def$cell$lat>=ylim[1] & grid.def$cell$lat<=ylim[2])

	#	check for mapproject parameters, if GDAL parameters present, GDAL superseds 
    if (borders && "projection" %in% names(field) && "orientation" %in% names(field) &&
		!use.rgdal) projected=TRUE
    else projected = FALSE

#	TODO: Need to think if this will ever be necessary
#    #   change limits if projection is used
#    if (projected){
#		#	here x and y are given in lat/lon and x and y refer to the original projection after
#        require(maps)
#        if ("parameters" %in% names(field)){
#            pro = mapproject(x, y, projection=field$projection, parameters=field$parameters, 
#				orientation=field$orientation)
#        }else{
#            pro = mapproject(x, y, projection=field$projection, parameters=NULL, 
#				orientation=field$orientation)
#        }
#        x = range(pro$x, na.rm=TRUE)
#        y = range(pro$y, na.rm=TRUE)
#    }       
#
#    #   change limits if rgdal is used
#	if (use.rgdal){
#		if (missing(xlim)) {
#			xx = x
#			nnx = nx
#		} else {
#			xx = xlim
#			nnx = round(diff(xx)/dx) + 1
#			xx[2] = xx[1] + (nnx-1) * dx
#		}
#		if (missing(ylim)) {
#			yy = y
#			nny = ny
#		} else {
#			yy = ylim
#			nny = round(diff(yy)/dy) + 1
#			yy[2] = yy[1] + (nny-1) * dy
#		}
#
#		#	get coordinates at border and center point of input grid
#		bp = SpatialPoints(coords=data.frame(
#        	x=c(seq(xx[1], xx[2], dx), rep(xx[2], nny), seq(xx[2], xx[1], -dx), 
#				rep(xx[1], nny), mean(xx)),
#        	y=c(rep(yy[1], nnx), seq(yy[1], yy[2], dy), rep(yy[2], nnx), 
#				seq(yy[2], yy[1], -dy), mean(yy))),
#        	proj4string=CRS(field$proj4string))
#		
#		use_ob_tran = grepl("[+]proj=ob_tran [+]o_proj=longlat", field$proj4string)
#
#		#	convert to lat/lon	(for use with maps)	
#		bp.ll = spTransform(bp, CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"), 
#			use_ob_tran=use_ob_tran)
#
#		xlim.ll = range(bp.ll@coords[,1])
#		ylim.ll = range(bp.ll@coords[,2])
#	}
    
	if (is.factor){
		levels = fac.levels	
	} else  {
    	#   zlim should hold the real range of the data, even if log transformation is done  
    	if (log.scale){

			#	check for negative values
        	msk = which(z[fld.msk]<=0)
			#	if zlim exists and contains negative lower and positive upper bound, try to 
			#	construct log scale for abosulte values
			#	else just clip negative values
			if (length(msk)>0 && zlim[1]<0 && zlim[2]>0 && !is.null(zlim)){
				nlevh = trunc(nlevels/2.)
				log.rng = 1E2
				levels = c(-10^(seq(log10(-zlim[1]), log10(-zlim[1]/log.rng), length.out=nlevh)), 
					0, 10^(seq(log10(zlim[2]/log.rng), log10(zlim[2]), length.out=nlevh)))

				zrng = range(z[fld.msk], finite=TRUE, na.rm=TRUE)
				nlevels = length(levels)
				if (open.scale){
					levels[1] = min(c(zrng[1], levels[1]-1))
					levels[length(levels)] = max(c(zrng[2], levels[length(levels)]+1))
				}

			} else {
				
		        if (length(msk)>0) {
        		    z[fld.msk][msk] = NA
    	    	    warning("Positive z required for log scale. Omitting negative values.")
		        }
    	    	if (missing(zlim) || is.null(zlim) || is.na(zlim)) {
					zlim = range(z[fld.msk], finite=TRUE, na.rm=TRUE)
				}
    		    if (all(is.na(zlim))) {
					zlim = c(0.1,1)        
				}
		        z[fld.msk] = log10(z[fld.msk])
			}

    	} else {	#	linear scale
        	if (missing(zlim) || is.null(zlim) || is.na(zlim)) {
				zlim = range(z[fld.msk], finite=TRUE, na.rm=TRUE)
			}
        	if (all(is.na(zlim))) {
				zlim = c(-1,1)
			}
    	}
		#	real data range
		zrng = range(z[fld.msk], finite=TRUE, na.rm=TRUE)
    
	    #   set initial levels 
	    if (missing(levels)) {
	        if (!any(!is.finite(zlim))){
            	if(log.scale) { 
					levels = pretty(log10(zlim), nlevels) 
				} else { 
					levels =  pretty(zlim, nlevels)        
				}
				#	
				if (open.scale){
					levels[1] = min(c(zrng[1], levels[1]-1))
					levels[length(levels)] = max(c(zrng[2], levels[length(levels)]+1))
				}
	        } else {
    	        levels = c(0,1)
	        }
    	}
	}

	if (is.factor){
		if (missing(col)){
			if (missing(palette.par)){
				col = color.palette(length(levels))
			} else {
				col = do.call(color.palette, c(list(n=length(levels)), palette.par))
			}
		}		
	} else {
	    if (missing(col)){
    	    if (missing(palette.par)){
            	col = color.palette(length(levels) - 1)
	        } else {
    	        col = do.call(color.palette, c(list(n=length(levels)-1), palette.par))
	        }
	    }   
	}
	
    nlevels = levels    
    ncol = col
    
    if (hide.lowest) {
         nlevels = nlevels[-1]
         ncol = ncol[-1]
         col = col[-1]
    } 
    
    if (inv.cols) {
        ncol = ncol[length(ncol):1]
        col = col[length(col):1]
    }


    # plot layout
    if (plot.key) {
        mar.orig <- (par.orig <- par(c("mar", "las", "mfcol")))$mar
        if (key.las==3){
            w <- (1 + mar.orig[2]) * par("csi") * 2.54
        } else {
            w <- (3 + mar.orig[2]) * par("csi") * 2.54
        }
        if (key.pos==4) layout(matrix(c(2, 1), nc = 2), widths = c(1, lcm(w)))
        else if (key.pos==2) layout(matrix(c(1, 2), nc = 2), widths = c(lcm(w), 1))
        else if (key.pos==1) layout(matrix(c(2, 1), nc = 1), heights = c(1, lcm(0.6*w)))
        else if (key.pos==3) layout(matrix(c(1, 2), nc = 1), heights = c(lcm(0.6*w), 1))        
    } else {
        mar.orig <- (par.orig <- par(c("mar", "las")))$mar
    }

    mar <- mar.orig

    colscale = list(levels=nlevels, color=ncol, las=key.las, key.pos=key.pos, 
		log.scale=log.scale, is.factor=is.factor, is.chron=is.chron, 
		border=key.border)

    if (!missing(key.axes)){
		colscale$key.axes = key.axes
    } else{ 
        colscale$key.format = key.format

		#	function for plotting key axes
        colscale$key.axes = function (nlevels, side, log.scale=FALSE, 
			irr.scale=FALSE, is.factor=NULL, key.format=NULL, 
			is.chron=NULL) { 

    		if (side %in% c(1,3)){
                yaxp = par("xaxp")                        
                side.axis = 1
            } else {
                yaxp = par("yaxp")
                side.axis = 4
            }

            dy = (yaxp[2]-yaxp[1])/yaxp[3]

            #   removing top and bottom values if open color scale 
            if (yaxp[2]>nlevels[length(nlevels)-1]) {
                yaxp[2] = yaxp[2]-dy
                yaxp[3] = yaxp[3] - 1
            }

            if (yaxp[1]<nlevels[2]) {
                yaxp[1] = yaxp[1]+dy #round(yaxp[1]+dy,-round(log10(dy)))
                yaxp[3] = yaxp[3] - 1
            }
            
			if (!is.null(is.factor) && is.factor){
				labels = nlevels
				at = seq(1, length(nlevels), 1)
				axis(side.axis, at=at, labels=labels, cex.axis=0.8, lwd=par("lwd"), tck = 0.)
			} else {
        	    #   irregular color scale                
    	        if (irr.scale){
                    at = 2:(length(nlevels)-1)
					at.vals = nlevels[2:(length(nlevels)-1)]
					if (length(at)>6){
						if (length(at) %% 2 ==0){
							msk = seq(2, length(at), 
								max(c(2, as.integer((length(at))/10.))))
						} else {
							msk = seq(1, length(at), 
								max(c(1, as.integer((length(at))/10.))))
						}
						at = at[msk]
						at.vals = at.vals[msk]
					}
                #   regular color scale
            	} else {
					if (length(nlevels)<7){
						at = nlevels
					} else {
						at = pretty(nlevels, n=10)
#	                    at = nlevels[seq(2, length(nlevels)-1, 
#							max(c(1, as.integer((length(nlevels)-2)/10.))) )]
					}
					at.vals = at
            	}

				#	format the labels
				if (is.null(key.format)){
	           	    if (log.scale){
						if (zlim[1]<0 && zlim[2]>0){
							labels = format(at.vals, digits=4, scientific=-2)
							if (max(nchar(labels))>5) {
								labels = format(at.vals, digits=3, scientific=-3)
							}
						} else {
							labels = format(10^at.vals, digits=4, scientific=-2)
							if (max(nchar(labels))>5) {
								labels = format(10^at.vals, digits=3, scientific=-3)
							}
						}
	   	            } else {
						labels = format(at.vals, digits=4, scientific=0)
						if (max(nchar(labels))>5) {
							labels = format(at.vals, digits=3, scientific=-2)
						}
	                }
				} else {
					if (log.scale){
						if (zlim[1]<0 && zlim[2]>0){
							labels = sprintf(key.format, at.vals)
						} else {
							labels = sprintf(key.format, 10^at.vals)
						}
					} else {
						labels = sprintf(key.format, at.vals)
					}
				}

				if (!is.null(is.chron) && is.chron){
					axis.chron(side.axis, cex.axis=0.8, lwd=par("lwd"), lwd.ticks=par("lwd"))
				} else {
					axis(side.axis, at=at, labels=labels, cex.axis=0.8, lwd=par("lwd"), 
						lwd.ticks=par("lwd"))
				}
			}
			return(at)
        } #	end of function definition

    }
    if (!missing(key.title)) colscale$key.title = key.title

    if (plot.key){
        plot.colorpalette(colscale, open.scale=open.scale)        
    }    

    mar <- mar.orig
	who = knock.knock()

    #   setting up plot window
    if (!add){
        if (who!="subplot") plot.new()
        plot.window(xlim, ylim, "", xaxs = xaxs, yaxs = yaxs, asp = asp)
		clip(par("usr")[1], par("usr")[2], par("usr")[3], par("usr")[4])

		if(!is.null(bg.img)){
			if (!class(bg.col)=="character"){
				bg.col = bg.col(30)
			}
			image(bg.img, zlim=bg.zlim, col=bg.col, add=TRUE)
		} else if (class(bg.col)=="character"){
			rect(par("usr")[1], par("usr")[3], par("usr")[2], par("usr")[4], col=bg.col,
				border=NA)
		}
    }
    

	############################################################
	#      MAIN PLOT 
	############################################################
    if (type=="grid") {

        # draw points
		if (is.factor){
			fz = z
			nlevels = seq(0.5, length(nlevels)+.5)
		} else {
			#	update: 2011-09-26	
			fz = as.numeric(cut(as.vector(z[fld.msk]), nlevels))
			fz[is.na(fz) & as.vector(z[fld.msk])<=nlevels[1]] = 1
			fz[is.na(fz) & as.vector(z[fld.msk])>=nlevels[length(nlevels)]] = length(nlevels)-1
		}
		
        #   plot the grid boxes
		if (open.scale){
			if (zlim[1] < nlevels[1]) nlevels[1] = zlim[1]
			if (zlim[2] > nlevels[length(nlevels)]) nlevels[length(nlevels)] = zlim[2]
		}

		poly = data.frame(
		    x = as.vector(icon.grid$vertex$lon[t(grid.def$vertex.of.cell[fld.msk,])]),
		    y = as.vector(icon.grid$vertex$lat[t(grid.def$vertex.of.cell[fld.msk,])]),
		    id = rep(fld.msk, each=3),
			col = rep(col[fz], each=3), stringsAsFactors=FALSE)
		lapply(split(poly, f=poly$id), function(x){
			polygon(x$x, x$y, col=x$col[1], border=grid.borders)})
			
	} else if (type=="vector"){

		if (add.vec.length){
			fz = as.numeric(cut(as.vector(z[fld.msk]), nlevels))
			fz[is.na(fz) & as.vector(z[fld.msk])<=nlevels[1]] = 1
			fz[is.na(fz) & as.vector(z[fld.msk])>=nlevels[length(nlevels)]] = length(nlevels)-1
	
    	    #   plot the grid boxes
			poly = data.frame(
			    x = as.vector(grid.def$vertex$lon[t(grid.def$vertex.of.cell[fld.msk,])]),
			    y = as.vector(grid.def$vertex$lat[t(grid.def$vertex.of.cell[fld.msk,])]),
		    	id = rep(fld.msk, each=3),
				col = rep(col[fz], each=3), stringsAsFactors=FALSE)
			lapply(split(poly, f=poly$id), function(x){
				polygon(x$x, x$y, col=x$col[1], border=grid.borders)})
		}
	
		#	normalise arrow lengths
		#	grid_units/inch 
		upi = c(diff(par("usr")[1:2]), diff(par("usr")[3:4]))/par("pin")

		#	use same scaling factor if asp was provided 
		if (is.na(asp)){
			upi[] = min(upi)
		}
				uu = uu[fld.msk]*upi[1]	#	vector_units * grid_units / inch
		vv = vv[fld.msk]*upi[2]
		xx = grid.def$cell$lon[fld.msk]
		yy = grid.def$cell$lat[fld.msk]
		vec.abs = max(sqrt(uu^2+vv^2))
		
		#	vec.len gives the length of a vector or unit length 1 in inches
		if (is.null(vec.len)){
			R.earth = 6371
			vec.len = grid.def$dx/R.earth*180/pi/vec.abs #	grid_units/vector_units
		}
		if (is.null(vec.ref)){
			head.len = vec.len * vec.abs * 0.2 / mean(upi) 
		} else {
			head.len = vec.len * vec.ref * 0.5
		}

		#	adjust length of vectors
		uu = uu*vec.len
		vv = vv*vec.len

		#	plot vector field
		arrows(xx-uu/2., yy-vv/2., xx+uu/2, yy+vv/2., 
			length=head.len, col=vec.col, lwd=vec.lwd)


		#	set length of reference arrow
			if (is.null(vec.ref)){
				vec.ref = pretty(c(0,max(z[fld.msk])/2.), n=1)
				if (length(vec.ref)>2){
					vec.ref = vec.ref[length(vec.ref)-1]
				} else {
					vec.ref = vec.ref[length(vec.ref)]
				}
			}
			vec.legend = paste(signif(vec.ref,3), vec.legend)

	#	do nothing
    } else {
		
	}
    
	############################################################
	#       add additional plot features 
	############################################################

	#	plot axis 
	#	no axis when projection is used
    if (!projected){
        #   standard axes
        if (missing(plot.axes)){
			if (axes) {
			#	borders=TRUE and no projection, assumes that we are dealing with a 
			#	regular long/lat grid
		        if (borders && !use.rgdal){
					at.x = pretty.geographical(xlim, n=10)
					at.y = pretty.geographical(ylim, n=10)

            	    at.x = axis(1, at=at.x, lwd=par("lwd"), lwd.ticks=par("lwd"))
                	at.y = axis(2, at=at.y, lwd=par("lwd"), lwd.ticks=par("lwd"))

	                if (missing(xlab)) xlab = expression(paste("Longitude (", degree, "E)"))
    	            if (missing(ylab)) ylab = expression(paste("Latitude (", degree, "N)"))
        	    } else {
            	    at.x = axis(1, lwd=par("lwd"), lwd.ticks=par("lwd"))
                	at.y = axis(2, lwd=par("lwd"), lwd.ticks=par("lwd"))
	            }
			} else {
				at.x = NULL
				at.y = NULL
			}
        } else {
			tmp = plot.axes()
			if (class(tmp)=="list") {
				at.x = tmp$at.x
				at.y = tmp$at.y
			} else {
				at.x = NULL
				at.y = NULL
			}
		}
    }
    
    #   plot title and axis labels
    if (missing(plot.title)){
        title(...)
        mtext(xlab, side=1, line=2, las=0, cex=par("cex"))
        mtext(ylab, side=2, line=2, las=0, cex=par("cex"))        
    } else {
		plot.title
	}

    # set projection parameters
    if (projected){
        projection=field$projection
        orientation = field$orientation
        parameters = field$parameters
    } 
     
    #   grid
	###################################################################################
    if (plot.grid){
        if (!projected) {
			if (!use.rgdal){
				#	standard long/lat
				###########################################################
#					at.lng = pretty.geographical(xlim, n=10)
#					at.lat = pretty.geographical(ylim, n=10)
				if (!is.null(at.x)){
	               	axis(1, at=at.x, tck=1, col=grid.col, lty=grid.lty, lwd=par("lwd"), 
						lwd.ticks=par("lwd")*grid.lwd, labels=FALSE)
				}
				if (!is.null(at.y)){
	                axis(2, at=at.y, tck=1, col=grid.col, lty=grid.lty, lwd=par("lwd"), 
						lwd.ticks=par("lwd")*grid.lwd, labels=FALSE)
				}

			#	PROJ4 projection 
			#########################################################
			} else {
				r = par("pin")[1]/par("pin")[2]
				at.nn = 6
				if(r>1) {
					nn.lng = at.nn 
					nn.lat = at.nn/r
				} else {
					nn.lng = at.nn * r
					nn.lat = at.nn	
				}
				at.lng = pretty.geographical(xlim.ll, n=nn.lng)
				nn.lng = length(at.lng)
				at.lat = pretty.geographical(ylim.ll, n=nn.lat)
				nn.lat = length(at.lat)

				#	grid lines
				tmp = vector("list", nn.lng)
				for (ii in 1:nn.lng){
					tmp[[ii]] = Line(data.frame(xx=rep(at.lng[ii], 100), 
						yy=seq(at.lat[1], at.lat[nn.lat], length.out=100)))
				}
				vert = Lines(tmp, ID="vert")

				tmp = vector("list", nn.lat)
				for (ii in 1:nn.lat){
					tmp[[ii]] = Line(data.frame(xx=seq(at.lng[1], at.lng[nn.lng], length.out=100), 
						yy=rep(at.lat[ii], 100)))
				}
				hori = Lines(tmp, ID="hori")
				
				grdlns = SpatialLines(list(vert, hori), 
					proj4string=CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))

				grdlns = spTransform(grdlns, CRS(field$proj4string), use_ob_tran=use_ob_tran)
				plot(grdlns, add=TRUE, col=grid.col, lty=3, lwd=2*par("lwd"))

				#	grid labels
				vert = SpatialPoints(data.frame(xx=at.lng, 
					yy=rep(at.lat[length(at.lat)/2], nn.lng)), 
					proj4string=CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))
				hori = SpatialPoints(data.frame(xx=rep(at.lng[length(at.lng)/2], nn.lat), 
					yy=at.lat), 
					proj4string=CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))

				vert = spTransform(vert, CRS(field$proj4string), use_ob_tran=use_ob_tran)
				hori = spTransform(hori, CRS(field$proj4string), use_ob_tran=use_ob_tran)
				
				text(vert@coords[,1], vert@coords[,2], at.lng, adj=c(-0.1, 1.1), col=grid.col)
				text(hori@coords[,1], hori@coords[,2], at.lat, adj=c(-0.1,-0.1), srt=90, 
					col=grid.col)

			}
		#	mapproject grid
		#############################################################
        } else {
            tmp.xlim = pretty(xlim.ll)
            tmp.xlim = range(tmp.xlim) +c(-1,1)*diff(tmp.xlim)[1]
            tmp.ylim = pretty(ylim.ll)
            tmp.ylim = range(tmp.ylim) + c(-1,1)*diff(tmp.ylim)[1]
            map.grid(c(tmp.xlim, tmp.ylim), col=grid.col, lty=3, cex=1)
        }
    }


    #  add polygons and lines from map databases (for example borders, rivers, lakes) 
    if (borders){
        library(maps)
		library(mapdata)

		if (class(map.db)=="character"){
			map.db = as.list(map.db)
		}
		nn.maps = length(map.db)
		if (nn.maps>1){
			if (length(map.source)<nn.maps) map.source = rep(map.source, length.out=nn.maps)	
			if (length(borders.col)<nn.maps) borders.col = rep(borders.col, length.out=nn.maps)	
			if (length(map.fill)<nn.maps) map.fill = rep(map.fill, length.out=nn.maps)
			if (length(map.lwd)<nn.maps) map.lwd = rep(map.lwd, length.out=nn.maps)
			if (length(map.lty)<nn.maps) map.lty = rep(map.lty, length.out=nn.maps)
		}

        if (projected) { 
			for (jj in nn.maps:1){
				try(my.map(map.db[[jj]], source=map.source[jj], xlim=xlim.ll, ylim=ylim.ll, 
					add=TRUE, wrap=TRUE, resolution=0, projection=projection, 
					orientation=orientation, parameters=parameters, col=borders.col[jj], 
					fill=map.fill[jj], lwd=map.lwd[jj], lty=map.lty[jj]))
			}
        } else if (use.rgdal){
			for (jj in nn.maps:1){
				if (map.source[jj]=="sp"){

					if (use_ob_tran){
						brd.sp = spTransform(map.db[[jj]], 
							CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))

						brd.sp = spTransform(brd.sp, CRS(field$proj4string), 
							use_ob_tran=use_ob_tran)
					} else {
						brd.sp = spTransform(map.db[[jj]], CRS(field$proj4string), 
							use_ob_tran=use_ob_tran)
					}

					if (map.fill[jj]){
						plot(brd.sp, add=TRUE, col=borders.col[jj], lwd=map.lwd[jj], 
							lty=map.lty[jj], border=NA)
					}else {
						plot(brd.sp, add=TRUE, col=borders.col[jj], lwd=map.lwd[jj], 
							lty=map.lty[jj])
					}
					
				} else {

					#	just get the data through the my.map function
					brd.lns = try(my.map(map.db[[jj]], source=map.source[jj], 
						xlim=xlim.ll, ylim=ylim.ll, 
						add=FALSE, wrap=TRUE, resolution=0, plot=FALSE), silent=TRUE)

					if (class(brd.lns)!="try-error"){
					#	remove points outside valid range
						brd.lns$x[brd.lns$x<(-180)] = -180
						brd.lns$x[brd.lns$x>(180)] = 180
						#	convert object of calss map to a Spatial object
						if (map.fill[jj]){
							brd.sp = map2SpatialPolygons(brd.lns, ID = brd.lns$names,
								proj4string = CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))
						} else {
							brd.sp = map2SpatialLines(brd.lns, 
								proj4string = CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))
						}
						#	coordinate transformation
						brd.sp = spTransform(brd.sp, CRS(field$proj4string), 
							use_ob_tran=use_ob_tran)
						#	plot
						#	TODO: Fill polygons
						if (map.fill[jj]){
							plot(brd.sp, add=TRUE, col=borders.col[jj], lwd=map.lwd[jj], 
								lty=map.lty[jj], border=NA)
						}else {
							plot(brd.sp, add=TRUE, col=borders.col[jj], lwd=map.lwd[jj], 
								lty=map.lty[jj])
						}
					} 
				}
			}
		} else {
			for (jj in nn.maps:1){
				try(my.map(map.db[[jj]], source=map.source[jj], 
					xlim=xlim.ll, ylim=ylim.ll, add=TRUE, 
					wrap=TRUE, col=borders.col[jj], resolution=0, fill=map.fill[jj], 
					lwd=map.lwd[jj], lty=map.lty[jj]))
			}
		}

    }

    #   add cities
    if (cities){
        library(maps)
        if (projected) {
			cities.par$projection = projection
			cities.par$orientation = orientation
			cities.par$parameters = parameters
			try(do.call(map.cities, cities.par))
        } else if (use.rgdal){
			#	obtain city locations

			cities.par$plot = FALSE
			cities.par$xlim = xlim.ll
			cities.par$ylim = ylim.ll

			cities.ll = try(do.call(my.cities, cities.par))

			if (nrow(cities.ll)>0) {
				#	convert to SpatialPoints
				cities.sp = SpatialPointsDataFrame(coords=cities.ll[,c("long", "lat")], 
					data=cities.ll, proj4string = CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))
				#	apply projection
				cities.sp = spTransform(cities.sp, CRS(field$proj4string), use_ob_tran=use_ob_tran)

				#	draw the points
				#	TODO: plotting parameter not included yet
				points(cities.sp, pch=1, cex=par("cex"))
				#	add labels
				if (cities.par$label){
					text(cities.sp$long, cities.sp$lat + par("cxy")[2]*par("cex"), 
						label=cities.sp$name, cex=par("cex"))
				}
			}

        } else {
			try(do.call(map.cities, cities.par))
		}
    }

    #   add markers
	#################################################
    if (length(pnts$x)>0) {
        if (projected) {
            tmp = mapproject(pnts$x, pnts$y, projection=projection, orientation=orientation, 
				parameters=parameters)
            pnts$x = tmp$x
            pnts$y = tmp$y
        } else if (use.rgdal){
			pnts.sp = SpatialPoints(cbind(pnts$x, pnts$y), 
				proj4string = CRS("+proj=longlat +ellps=WGS84 +datum=WGS84"))
				#	apply projection
			pnts.sp = spTransform(pnts.sp, CRS(field$proj4string), use_ob_tran=use_ob_tran)
			pnts$x = pnts.sp@coords[,1]
			pnts$y = pnts.sp@coords[,2]
		}
		
		if (is.null(pnts$pch)) pnts$pch=19
		if (is.null(pnts$col)) pnts$col=1
		if (is.null(pnts$lwd)) pnts$lwd=1
		if (is.null(pnts$cex)) pnts$cex=1
		if (is.null(pnts$pos)) pnts$pos=3
		if (is.null(pnts$font)) pnts$font=1
		if (is.null(pnts$font.cex)) pnts$font.cex=1
		if (is.null(pnts$bg)) pnts$bg = par("bg")
		if (is.null(pnts$offset)) pnts$offset = 0.5

		points(pnts$x, pnts$y, pch=pnts$pch, col=pnts$col, lwd=pnts$lwd*par("lwd"), 
			cex=pnts$cex, bg=pnts$bg)
		text(pnts$x, pnts$y, pnts$name, pos=pnts$pos, cex=pnts$font.cex, col=pnts$col, 
			font=pnts$font, offset=pnts$offset)
    }

	#	add vector legend
	if (type=="vector"){	
		if (!is.null(vec.legend)){

			bx.width = vec.ref*vec.len*upi[1] + 
				2*par("cin")[1] * upi[1]	#	width is vector length + 2 character widths
			bx.width = max(c(bx.width, strwidth(vec.legend, "user") + 2*par("cin")[1]*upi[1]))
			bx.width = bx.width * par("cex")
			bx.height = 2*par("cin")[2] * upi[2]		#	height is 2 character heights
			bx.height = bx.height * par("cex")

			if (vec.leg.pos=="topleft"){
				bx.ll.x = par("usr")[1]
				bx.ll.y = par("usr")[4]-bx.height
				bx.ur.x = par("usr")[1]+bx.width
				bx.ur.y = par("usr")[4]

				arw.l = par("usr")[1]+par("cin")[1] * upi[1]
				arw.r = par("usr")[1]+par("cin")[1] * upi[1] + vec.ref*vec.len*upi[1]
				arw.y = par("usr")[4]-0.5*par("cin")[2] * upi[2]

				leg.side = 3
				leg.line = -2.5
				leg.adj = 0.01
			} else if (vec.leg.pos=="topright"){
				bx.ll.x = par("usr")[2]-bx.width
				bx.ll.y = par("usr")[4]-bx.height
				bx.ur.x = par("usr")[2]
				bx.ur.y = par("usr")[4]

				arw.l = par("usr")[2] - par("cin")[1]*upi[1] - vec.ref*vec.len*upi[1]
				arw.r = par("usr")[2] - par("cin")[1]*upi[1] 
				arw.y = par("usr")[4]-0.5*par("cin")[2] * upi[2]

				leg.side = 3
				leg.line = -2.5
				leg.adj = 0.99 
			} else if (vec.leg.pos=="bottomright"){
				bx.ll.x = par("usr")[2]-bx.width
				bx.ll.y = par("usr")[3]
				bx.ur.x = par("usr")[2]
				bx.ur.y = par("usr")[3]+bx.height

				arw.l = par("usr")[2] - par("cin")[1]*upi[1] - vec.ref*vec.len*upi[1]
				arw.r = par("usr")[2] - par("cin")[1]*upi[1] 
				arw.y = par("usr")[3]+0.5*par("cin")[2] * upi[2]

				leg.side = 1
				leg.line = -2
				leg.adj = 0.99 
			} else if (vec.leg.pos=="bottomleft"){
				bx.ll.x = par("usr")[1]
				bx.ll.y = par("usr")[3]
				bx.ur.x = par("usr")[1]+bx.width
				bx.ur.y = par("usr")[3]+bx.height

				arw.l = par("usr")[1]+par("cin")[1] * upi[1]
				arw.r = par("usr")[1]+par("cin")[1] * upi[1] + vec.ref*vec.len*upi[1]
				arw.y = par("usr")[3]+0.5*par("cin")[2] * upi[2]

				leg.side = 1
				leg.line = -2
				leg.adj = 0.01
			}

			#	rectangular box arround arrow
			rect(bx.ll.x, bx.ll.y, bx.ur.x, bx.ur.y, col=vec.leg.col, border=par("fg"))
			#	arrow
			arrows(arw.l, arw.y, arw.r, arw.y, length=head.len, col=vec.col, lwd=vec.lwd)
			#	legend text
			mtext(vec.legend, leg.side, leg.line, adj=leg.adj, cex=par("cex"))
		}	
	}

	#	add box around plot region
    if (frame.plot) box()

    return(invisible(colscale))    
}



###############################################################################################
#	Examples
###############################################################################################


